clc;
clear;
%Microstrip Rectangular Patch Antenna pattern
%input data of antenna
fr=input('Razavizadeh tell you enter Freq in GHz: ');
Er=input('enter Substrate Dielectric Constant: ');
h=input('enter Substrate Thickness in mm: ');

w=(150/fr)*sqrt(2/(Er+1)); %milimeter
Ereff=((Er+1)/2)+((Er-1)/2)*(1/sqrt(1+12*h/w));%effective dielectric constant
vp=300/sqrt(Ereff); %Phase Velocity in substrate
Lambdag=vp/fr; %milimeter
Leff=Lambdag/2; %milimeter
Delta_L=0.412*(Ereff+0.3)*((w/h)+0.264)/((Ereff-0.258)*((w/h)+0.8)); %milimeter
L=Leff-(2*Delta_L);
m=0;n=0;
for phi= 0.01:0.05:2*pi;
    n=n+1;m=0;
    for teta= 0.01:0.01:pi/2;
        m=m+1;
        FE(m,n)=abs(cos((pi*L/Lambdag)*sin(teta))); % E_Plane Pattern
        FH(m,n)=abs(cos(teta)*sin((pi*w/Lambdag)*sin(teta))/((pi*w/Lambdag)*sin(teta))); %H_Plane Pattern
        Phi(m,n)=phi;
        Theta(m,n)=teta;
    end;
end;
disp('width (mm)');
disp(w);
disp('Lenght(mm)');
disp(L);
figure;polar(Theta(:,1),abs(FE(:,1)));
FE_max=max(abs(FE(:,1)));
xx=FE.*sin(Theta).*cos(Phi);
yy=FE.*sin(Theta).*sin(Phi);
zz=FE.*cos(Theta);
figure;surfl(xx,yy,zz);
colormap('copper');
legend(['E-Plane ;','Emax: ',num2str(FE_max)]);

figure;polar(Theta(:,1),abs(FH(:,1)));
xx=FH.*sin(Theta).*cos(Phi);
yy=FH.*sin(Theta).*sin(Phi);
zz=FH.*cos(Theta);
figure;surfl(xx,yy,zz);
colormap('copper');
legend(['H-Plane']);